
/**
 * Module dependencies.
 */

var connect = require('./');

// expire sessions within a minute
// /favicon.ico is ignored, and will not 
// receive req.session

connect(
    connect.cookieParser()
  , connect.session({ secret: 'keyboard cat', cookie: { maxAge: 60000 }})
  , connect.favicon()
  , function(req, res, next){
    var sess = req.session;
    if (sess.views) {
      sess.cookie.maxAge = 90000;
      res.setHeader('Content-Type', 'text/html');
      res.write('<p>views: ' + sess.views + '</p>');
      res.write('<p>expires in: ' + (sess.cookie.maxAge / 1000) + 's</p>');
      res.end();
      sess.views++;
    } else {
      sess.views = 1;
      setInterval(function(){
        var prev = sess.views;
        sess.reload(function(err){
          if (err) console.error(err.toString());
          console.log();
          console.log('previous views %d, updated %d', prev, req.session.views);
          console.log('time remaining until expiry: %ds', (req.session.cookie.maxAge / 1000));
        });
      }, 3000);
      res.end('welcome to the session demo. refresh!');
    }
  }
).listen(3000);
console.log('port 3000: 1 minute expiration demo');